#include <string.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

int temperature = 20;

void errExit(char *message)
{
	perror(message);
	exit(EXIT_FAILURE);
}

static void cas_special(int sig)
{
	--temperature;
}

static void urgence(int sig)
{
	++temperature;
}

int main(int argc, const char *argv[])
{
	struct sigaction sa;

	sigfillset(&sa.sa_mask);
	sa.sa_flags = SA_RESTART;
	sa.sa_handler = cas_special;
	if (sigaction(SIGUSR1, &sa, NULL) == -1) {
		errExit("sigaction");
	}

	sigfillset(&sa.sa_mask);
	sa.sa_flags = SA_RESTART;
	sa.sa_handler = urgence;
	if (sigaction(SIGUSR2, &sa, NULL) == -1) {
		errExit("sigaction");
	}

	sigfillset(&sa.sa_mask);
	sa.sa_flags = SA_RESTART;
	sa.sa_handler = SIG_IGN;
	if (sigaction(SIGINT, &sa, NULL) == -1) {
		errExit("sigaction");
	}

	printf("Mon PID est : %ld\n", (long) getpid());

	while (1) {
		printf("Temprature courante : %d\n", temperature);
		sleep(1);
	}

	return EXIT_SUCCESS;
}
